using UnityEngine;
using System.Collections;

public class Enemy : MonoBehaviour
{
	void Awake()
	{
		MyLittleEnemyManager.Get().AddEnemy(this);
		gameObject.SetActiveRecursively(false);
	}
	
    public void OnTriggerEnter (Collider other)
	{
		if(other.gameObject.GetComponent<PlayerController>() != null)
		{
			if(PlayerController.Get().Attacking)
			{
				gameObject.SetActiveRecursively(false);
				MyLittleEnemyManager.Get().ReturnToPool(this);
				// if killed with something that is not a charge, make player recover one charge point
				if(PlayerController.Get().LastMove != 1)
				{
					MyLittleMouseTracker.Get().RecoverCharge();
				}
				// recover air dahses when killing something.
				PlayerController.Get().RecoverMoves();
				MyLittleHighScore.Get().Kill();
			}
			else
			{
				GenericInfo.Get().TakeDamage();
			}
		}
	}
	
	public void Place(Vector3 position)
	{
		gameObject.SetActiveRecursively(true);
		transform.position = position;
	}
	
	void Update()
	{
		if (transform.position.x < MyLittleCamera.Get().transform.position.x-400)
		{
			gameObject.SetActiveRecursively(false);
			MyLittleEnemyManager.Get().ReturnToPool(this);
		}
	}
}