﻿using UnityEngine;
using System.Collections;

public class GenericInfo : MonoBehaviour
{
	static private GenericInfo instance;
	
    public float gravity;
	public float speed = 2;
	public int startHealth = 3;
	public Texture2D healthBarIcon;
	public Texture2D helpIcon;
	public Texture2D skipIcon;
	public Texture2D keys;
	public Texture2D cheat;
	
	private float startingSpeed;
	private int health;
	private bool cheatUnlocked = false; // change this to false!!!!!!!
	private bool bossUnlocked = false; // change this to false!!!!!!!
	private int displayCheat = 0;
	
	void Awake()
	{
		instance = this;
		startingSpeed = speed;
		health = startHealth;
	}
	
	public static GenericInfo Get()
	{
		return instance;
	}
	
	public void Reset()
	{
		speed = startingSpeed;
		health = startHealth;
	}
	
	void Update()
	{
		if(Input.GetButtonDown("CheatButton"))
		{
			CheatToReachBoss();
		}
		if(Input.GetButtonDown("Boss"))
		{
			SkipToDiscord();
		}
		if(MyLittleCamera.Get().transform.position.x > 7980)
		{
			speed = 3.6f;
			if(!cheatUnlocked)
			{
				displayCheat = 460;
			}
			cheatUnlocked = true;
		}
		if(MyLittleCamera.Get().transform.position.x > 8490)
		{
			speed = 4.5f;
		}
		if(MyLittleCamera.Get().transform.position.x > 13500)
		{
			bossUnlocked = true;
		}
	}
	
	private void DisplayCheatUnlocked()
	{
		// pop up the cheat unlocked pic for a few seconds.
		
	}
	
	void OnGUI()
	{
		// display a number of healthbars in teh bottom left corned based on how much health the player have
		for(int i = 0; i < health; i++)
		{
			GUI.DrawTexture(new Rect(4+i*34, Screen.height - 66, 32, 64), healthBarIcon);
		}
		
		if(Input.GetButton("Help"))
		{
			// display help popup
			GUI.DrawTexture(new Rect(100, 100, 512, 512), keys);
		}
		
		// display help in bottom left corner
		if(MyLittleCamera.Get().transform.position.x < 500)
		{
			GUI.DrawTexture(new Rect(Screen.width - 256, Screen.height - 64, 256, 64), helpIcon);
			if(cheatUnlocked)
			{
				GUI.DrawTexture(new Rect(Screen.width - 256, Screen.height - 128, 256, 64), skipIcon);
			}
		}
		if(displayCheat > 0)
		{
			displayCheat--;
			GUI.DrawTexture(new Rect(Screen.width/2 - 128, Screen.height/2 - 256, 256, 256), cheat);
		}
	}
	
	public void CheatToReachBoss()
	{
		if(cheatUnlocked)
		{
			MyLittleResetter.Reset();
			print("Cheating!");
			// set thelevel managers index to 30
			MyLittleLevelManager.Get().SkipTo30();
			
			// move player and camera into position
			PlayerController.Get().transform.position = new Vector3(7680, 0, 0);
			MyLittleCamera.Get().transform.position = new Vector3(7680, 0, -48.69771f);
			
			speed = 3.377f;
		}
	}
	
	public void SkipToDiscord()
	{
		if(bossUnlocked)
		{
			MyLittleResetter.Reset();
			print("SkippingToBoss!");
			// set thelevel managers index to 30
			MyLittleLevelManager.Get().SkipTo30();
			
			// move player and camera into position
			PlayerController.Get().transform.position = new Vector3(13500, 0, 0);
			MyLittleCamera.Get().transform.position = new Vector3(13500, 0, -48.69771f);
		}
	}
	
	public void TakeDamage()
	{
		health--;
		if(health < 1)
		{
			MyLittleResetter.Reset();
			MyLittleSoundManager.Get().Crash();
		}
		else
		{
			MyLittleSoundManager.Get().Hurt();
		}
	}
}