﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class MyLittleEnemyManager : MonoBehaviour
{
    private List<Enemy> activeEnemies = new List<Enemy>();
	private List<Enemy> enemyPool = new List<Enemy>();
	static private MyLittleEnemyManager instance;	
	
	static public MyLittleEnemyManager Get()
	{
		if(instance == null)
		{
			GameObject tempGO = new GameObject("unimportnat name");
			instance = tempGO.AddComponent<MyLittleEnemyManager>();
		}
		return instance;
	}
	
	public void PlaceEnemy(Vector3 position)
	{
		// move random enemy from the pool to the active list, and place it on the screen.
		int randomIndex = Random.Range(0, enemyPool.Count);
		Enemy tempEnemy = enemyPool[randomIndex];
		enemyPool.RemoveAt(randomIndex);
		
		tempEnemy.Place(position);
		activeEnemies.Add(tempEnemy);
		
	}
	
	public void ReturnToPool(Enemy enemy)
	{
		// remove the enemy from the active and place it in the pool
		activeEnemies.Remove(enemy);
		enemyPool.Add(enemy);
	}
	
	public void AddEnemy(Enemy enemy)
	{
		enemyPool.Add(enemy);
	}
	
	public void Reset()
	{
		// reset all enemy positions
		while(activeEnemies.Count > 0)
		{
			ReturnToPool(activeEnemies[0]);
		}
		
		foreach(Enemy enemy in enemyPool)
		{
			enemy.transform.position = new Vector3(0, 500, 0);
			enemy.gameObject.SetActiveRecursively(false);
		}
	}
}