using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class MyLittleLevelManager : MonoBehaviour
{
	static private MyLittleLevelManager instance;
    //move stuffs forward is what this class does, making sure there is always a floor ahead.
	private List<SetPiece> setPiecePool = new List<SetPiece>();
	private List<SetPiece> usedPieces = new List<SetPiece>();
	private int nextTilePosition = 1;
	public bool bossFight = false;  // MyLittleLevelManager.Get().bossFight 
	public bool setupBossFight = false;  // MyLittleLevelManager.Get().setupBossFight 
	
	private float enemyTimer = 0;
	
	public bool Level2 // MyLittleLevelManager.Get().Level2
	{
		set{}
		get
		{
			return (MyLittleCamera.Get().transform.position.x > 8600);
		}
	}
	
	static public MyLittleLevelManager Get()
	{
		if(instance == null)
		{
			GameObject tempGO = new GameObject("something");
			instance = tempGO.AddComponent<MyLittleLevelManager>();
		}
		return instance;
	}
	
	public void Reset()
	{
		nextTilePosition = 1;
		// move all the things in the used to the pool
		while(usedPieces.Count > 0)
		{
			setPiecePool.Add(usedPieces[0]);
			usedPieces.RemoveAt(0);
		}
		foreach(SetPiece piece in setPiecePool)
		{
			piece.transform.position = new Vector3(0, 500, 0);
		}
		setupBossFight = false;
		bossFight = false;
	}
	
	public void StartBossFight()
	{
		bossFight = true;
		// start moving upwards
	}
	
	public void GiveSetPiece(SetPiece piece)
	{
		setPiecePool.Add(piece);
	}
	
	void Update()
	{
		// if far enough to the left, move a random piece from the available pool into position.
		float maxX = nextTilePosition*256-260;
		if(!bossFight)
		{
			
			if(MyLittleCamera.Get().transform.position.x > maxX)
			{
				if(nextTilePosition < 30)
				{
					MovePiece();
					// boss stage
				}
				// if futher than 8600, start spawning second stage stuffs...  lods and lots and lots of enemies mostly.
				else if(MyLittleCamera.Get().transform.position.x > 8600)
				{
					enemyTimer -= Time.deltaTime;
					if(enemyTimer <= 0)
					{
						SpawnLevel2EnemyArray();
						enemyTimer = 1f;
					}
					if(MyLittleCamera.Get().transform.position.x > 13500)
					{
						// spawn discord
						setupBossFight = true;
					}
				}
			}
		}
		
	}
	/// <summary>
	/// Moves a piece to the front.
	/// </summary>
	private void MovePiece()
	{
		GenericInfo.Get().speed += 0.06f;		
		
		// take/remove a random piece from the pool
		int randomValue = Random.Range(0, setPiecePool.Count);
		SetPiece tempSP = setPiecePool[randomValue];
		setPiecePool.RemoveAt(randomValue);
		
		// push it into the usedPieces
		usedPieces.Add(tempSP);
		
		// move it into position
		tempSP.moveIntoPosition(nextTilePosition);
		
		// clear the first empy out of the usedPieces and move it into the pool
		if(usedPieces.Count > 3)
		{
			setPiecePool.Add(usedPieces[0]);
			usedPieces.RemoveAt(0);
		}
		
		// move the tile index forward.
		nextTilePosition++;
	}
	
	private void SpawnLevel2EnemyArray()
	{
		// place 1 to three random enemies just outside the screen to the right
		int numberOfEnemies = Random.Range(1, 4);
		for(var i = 0; i < numberOfEnemies; i++)
		{
			MyLittleEnemyManager.Get().PlaceEnemy(new Vector3(MyLittleCamera.Get().transform.position.x+130+(Random.Range(0f, 100f)), Random.Range(-40f, 100f), 0));
		}
	}
	
	public void SkipTo30()
	{
		nextTilePosition = 30;
	}
}