﻿using UnityEngine;
using System.Collections;

public class MyLittleMouseTracker : MonoBehaviour
{
	static private MyLittleMouseTracker instance;
	
    private Texture2D cursor;
	
	public Texture2D cursorEmpty;
	public Texture2D cursor1;
	public Texture2D cursor2;
	public Texture2D cursor3;
	public Texture2D cursorFull;
	public float stage2Multiplier;
	
	public Texture2D targetCursor;
	public int chargeRecoverOnKill = 2;
	public int chargeRecoveryRate = 5;
	public int sensitivity = 90;
	
	private Texture2D usedCursor;
	private Vector3 lastMouseClick;
	private bool disableInput = true;
	private float chargePower = 4;
	// charge cost 2. cant charge with less than 2 power.
	// max power is 4
	// recover 2 chanrge when killing with non charge
	// recover 1 charge every
	
	private float hornCharge = 0;
	private Animator ani;
	void Start()
	{
		Screen.showCursor = false;
		ani = PlayerController.Get().GetComponent<Animator>();; 
		
	}
	static public MyLittleMouseTracker Get()
	{
		return instance;
	}
	
	
	void Awake()
	{
		usedCursor = cursor;
		instance = this;
		
	}
	
	
	
	void Update()
	{
		if(MyLittleLevelManager.Get().bossFight)
		{
			hornCharge += Time.deltaTime;
			if(hornCharge > 1.5f)
			{
				ani.chargeLevel = 1;
				if(hornCharge > 3)
					ani.chargeLevel = 2;
				if(hornCharge > 4.5f)
					ani.chargeLevel = 3;
				if(hornCharge > 6)
					ani.chargeLevel = 4;
				
				if(Input.GetMouseButtonDown(0))
				{
					PlayerController.Get().Shoot(ani.chargeLevel);
					hornCharge = 0;
				}
			}
			else
			{
				ani.chargeLevel = 0;
			}
		}
		
		if(chargePower < 4)
		{
			// recover faster at stage2
			if(MyLittleCamera.Get().transform.position.x > 8600)
			{
				chargePower += stage2Multiplier * Time.deltaTime/chargeRecoveryRate;
			}
			else
			{
				chargePower += Time.deltaTime/chargeRecoveryRate;
			}
		}
		else
		{
			chargePower = 4;
		}
		
		cursor = cursorEmpty;
		if(chargePower >= 1)
			cursor = cursor1;
		if(chargePower >= 2)
			cursor = cursor2;
		if(chargePower >= 3)
			cursor = cursor3;
		if(chargePower >= 4)
			cursor = cursorFull;
		
		
		ChargeNode temp = MyLittleChargeNodeOrganizer.Get().GetTargetAtPosition(MyLittleCamera.Get().camera.ScreenToWorldPoint(Input.mousePosition));
		
		if(temp !=  null && chargePower >= 2)
		{
			usedCursor = targetCursor;
			// charge this target if click
			if(Input.GetMouseButtonUp(0))
			{
				PlayerController.Get().Charge(temp);
				disableInput = true;
				chargePower -= 2;
			}
		}
		else
		{
			usedCursor = cursor;
		}
		
		if(Input.GetMouseButtonDown(0))
		{
			lastMouseClick = Input.mousePosition;
		}
		
		if(Input.GetMouseButton(0))
		{
			if(!disableInput)
			{
				if(Input.mousePosition.x > lastMouseClick.x + sensitivity)
				{
					PlayerController.Get().Dash();
					disableInput = true;
				}
				else if(Input.mousePosition.y > lastMouseClick.y + sensitivity)
				{
					PlayerController.Get().AirJump();
					disableInput = true;
				}
				else if(Input.mousePosition.y < lastMouseClick.y - sensitivity)
				{
					PlayerController.Get().Dive();
					disableInput = true;
				}
				else if(Input.mousePosition.x < lastMouseClick.x - sensitivity)
				{
					PlayerController.Get().SlowDown();
					disableInput = true;
				}
			}
		}
		else
		{
			disableInput = false;
		}
	}
	
    void OnGUI()
    {
		GUI.DrawTexture(new Rect(Input.mousePosition.x-32, Screen.height - Input.mousePosition.y-32, 64, 64), usedCursor);
    }
	
	public void RecoverCharge()
	{
		chargePower += chargeRecoverOnKill;
	}
	
	public void Reset()
	{
		chargePower = 4;
	}
}

/*
private int cursorWidth = 32;
private int cursorHeight = 32;

void Start()
{
    Screen.showCursor = false;
}


void OnGUI()
{
    GUI.DrawTexture(new Rect(Input.mousePosition.x, Screen.height - Input.mousePosition.y, cursorWidth, cursorHeight), cursorImage);
}
}
*/