﻿using UnityEngine;
using System.Collections;

public class MyLittleSoundManager
{
    static public MyLittleSoundManager instance;
	private AudioSource sfxPlayer;
	private AudioSource hoofPlayer;
	
	
	static public MyLittleSoundManager Get()
	{
		if(instance == null)
		{
			instance = new MyLittleSoundManager();
		}
		
		return instance;
	}
	
	MyLittleSoundManager()
	{
		GameObject tempGO = new GameObject("Audio");
		tempGO.AddComponent<AudioListener>();
		sfxPlayer = tempGO.AddComponent<AudioSource>();
		hoofPlayer = tempGO.AddComponent<AudioSource>();
		hoofPlayer.volume = 0.5f;
	}
	
	private AudioClip hurt;
	public void Hurt()
	{
		
		if(hurt == null)
		{
			hurt = Resources.Load("Hurt") as AudioClip;
		}
		sfxPlayer.clip = hurt;
		sfxPlayer.Play();
		
	}
	
	private AudioClip crash;
	public void Crash()
	{
		
		if(crash == null)
		{
			crash = Resources.Load("Crash") as AudioClip;
		}
		sfxPlayer.clip = crash;
		sfxPlayer.Play();
	}
	
	private AudioClip beat1;
	private AudioClip beat2;
	private AudioClip beat3;
	public void HoofBeat(int i)
	{
		if(beat1 == null)
		{
			beat1 = Resources.Load("HoofBeat1") as AudioClip;
			beat2 = Resources.Load("HoofBeat2") as AudioClip;
			beat3 = Resources.Load("HoofBeat3") as AudioClip;
		}
		switch(i)
		{
		case 1 : hoofPlayer.clip = beat1; break;
		case 2 : hoofPlayer.clip = beat2; break;
		case 3 : hoofPlayer.clip = beat3; break;
		}
		hoofPlayer.Play();
		
	}
	
	public AudioClip wingFlap;
	public void WingFlap()
	{
		if(wingFlap == null)
		{
			wingFlap = Resources.Load("Flap") as AudioClip;
		}
		hoofPlayer.clip = wingFlap;
		hoofPlayer.Play();
	}
}
