﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class SetPiece : MonoBehaviour
{
	public int minimumEnemies = 1;
	
	private List<Transform> spawnPoints = new List<Transform>();
	
	void Awake()
	{
		MyLittleLevelManager.Get().GiveSetPiece(this);
	}
	
    public void moveIntoPosition(int x)
	{
		transform.position = new Vector3(x*256, 0, 0);
		// decide how many enemies should be placed on this set pieces
		int numberOfEnemies = Random.Range(minimumEnemies, 4);
		
		// if no spawn points, can't spawn
		if(numberOfEnemies > spawnPoints.Count)
		{
			numberOfEnemies = spawnPoints.Count;
		}
		// place them
		for(int i = 0; i < numberOfEnemies; i++)
		{
			MyLittleEnemyManager.Get().PlaceEnemy(spawnPoints[Random.Range(0, spawnPoints.Count)].position);
		}
	}
	
	public void AddSpawn(Transform spawn)
	{
		spawnPoints.Add(spawn);
	}
}